diff -urN ../sys/dev/en/midway.c ./dev/en/midway.c
--- ../sys/dev/en/midway.c	Sat Jan 29 23:38:04 2000
+++ ./dev/en/midway.c	Tue Oct  2 22:06:19 2001
@@ -48,6 +48,26 @@
  *   I would also like to thank Werner for promptly answering email and being
  *   generally helpful.
  */
+/*
+ *  1997/12/02, major update on 1999/04/06 kjc
+ *    new features added:
+ *	- BPF support (link type is DLT_ATM_RFC1483)
+ *	  BPF understands only LLC/SNAP!! (because bpf can't
+ *	  handle variable link header length.)
+ *	  (bpfwrite should work if atm_pseudohdr and LLC/SNAP are prepended.)
+ *	- support vc shaping
+ *	- integrate IPv6 support.
+ *	- support pvc sub interface
+ *
+ *	  initial work on per-pvc-interface for ipv6 was done
+ *	  by Katsushi Kobayashi <ikob@cc.uec.ac.jp> of the WIDE Project.
+ * 	  some of the extensions for pvc subinterfaces are merged from
+ *	  the CAIRN project written by Suresh Bhogavilli (suresh@isi.edu).
+ *
+ *    code cleanup:
+ *	- remove WMAYBE related code.  ENI WMAYBE DMA doen't work.
+ *	- remove updating if_lastchange for every packet.
+ */
 
 #undef	EN_DEBUG
 #undef	EN_DEBUG_RANGE		/* check ranges on en_read/en_write's? */
@@ -108,7 +128,6 @@
 #endif /* EN_DEBUG */
 
 #ifdef __FreeBSD__
-#include "en.h"			/* XXX for midwayvar.h's NEN */
 #include "opt_inet.h"
 #include "opt_natm.h"
 #include "opt_ddb.h"
@@ -126,6 +145,7 @@
 #include <sys/device.h>
 #endif
 #include <sys/sockio.h>
+#include <sys/malloc.h>
 #include <sys/mbuf.h>
 #include <sys/socket.h>
 #include <sys/proc.h>
@@ -144,19 +164,15 @@
 #include <netnatm/natm.h>
 #endif
 
-#if !defined(sparc) && !defined(__FreeBSD__)
-#include <machine/bus.h>
-#endif
-
 #if defined(__NetBSD__) || defined(__OpenBSD__)
+#include <machine/bus.h>
 #include <dev/ic/midwayreg.h>
 #include <dev/ic/midwayvar.h>
-#if defined(__alpha__)
-/* XXX XXX NEED REAL DMA MAPPING SUPPORT XXX XXX */
-#undef vtophys
-#define	vtophys(va)	alpha_XXX_dmamap((vm_offset_t)(va))
-#endif
 #elif defined(__FreeBSD__)
+#include <sys/bus.h>
+#include <machine/bus.h>
+#include <sys/rman.h>
+#include <machine/resource.h>
 #include <machine/clock.h>              /* for DELAY */
 #include <dev/en/midwayreg.h>
 #include <dev/en/midwayvar.h>
@@ -168,6 +184,22 @@
 
 #endif	/* __FreeBSD__ */
 
+#if defined(__alpha__)
+/* XXX XXX NEED REAL DMA MAPPING SUPPORT XXX XXX */
+#undef vtophys
+#define	vtophys(va)	alpha_XXX_dmamap((vm_offset_t)(va))
+#endif
+
+#ifdef ATM_PVCEXT
+# ifndef NATM
+   /* this is for __KAME__ */
+#  include <netinet/in.h>
+# endif
+# if defined(__KAME__) && defined(INET6)
+#  include <netinet6/in6_ifattach.h>
+# endif
+#endif /*ATM_PVCEXT*/
+
 #include "bpf.h"
 #if NBPF > 0
 #include <net/bpf.h>
@@ -204,6 +236,7 @@
 
 static int en_dma = EN_DMA;		/* use DMA (switch off for dbg) */
 
+#ifndef __FreeBSD__
 /*
  * autoconfig attachments
  */
@@ -211,6 +244,7 @@
 struct cfdriver en_cd = {
     0, "en", DV_IFNET,
 };
+#endif
 
 /*
  * local structures
@@ -295,6 +329,17 @@
 STATIC INLINE	void en_write __P((struct en_softc *, u_int32_t,
 		    u_int32_t)) __attribute__ ((unused));
 
+#ifdef ATM_PVCEXT
+static void rrp_add __P((struct en_softc *, struct ifnet *));
+static struct ifnet *en_pvcattach __P((struct ifnet *));
+static int en_txctl __P((struct en_softc *, int, int, int));
+static int en_pvctx __P((struct en_softc *, struct pvctxreq *));
+static int en_pvctxget __P((struct en_softc *, struct pvctxreq *));
+static int en_pcr2txspeed __P((int));
+static int en_txspeed2pcr __P((int));
+static struct ifnet *en_vci2ifp __P((struct en_softc *, int));
+#endif
+
 /*
  * macros/inline
  */
@@ -310,7 +355,7 @@
  * cooked read/write macros
  */
 
-#define EN_READ(SC,R) ntohl(en_read(SC,R))
+#define EN_READ(SC,R) (u_int32_t)ntohl(en_read(SC,R))
 #define EN_WRITE(SC,R,V) en_write(SC,R, htonl(V))
 
 #define EN_WRAPADD(START,STOP,CUR,VAL) { \
@@ -623,7 +668,7 @@
       if ((m->m_flags & M_EXT) == 0) {
 	m_free(m);
 	m_freem(top);
-	return(NULL);	  /* out of mbuf clusters */
+	return(NULL);	/* out of mbuf clusters */
       }
       m->m_len = MCLBYTES;
     }
@@ -700,7 +745,7 @@
 	(MID_IS_SABRE(reg)) ? "sabre controller, " : "",
 	(MID_IS_SUNI(reg)) ? "SUNI" : "Utopia",
 	(!MID_IS_SUNI(reg) && MID_IS_UPIPE(reg)) ? " (pipelined)" : "",
-	(long)(sc->en_obmemsz / 1024));
+	(long)sc->en_obmemsz / 1024);
 
   if (sc->is_adaptec) {
     if (sc->bestburstlen == 64 && sc->alburst == 0)
@@ -725,6 +770,7 @@
   ifp->if_ioctl = en_ioctl;
   ifp->if_output = atm_output;
   ifp->if_start = en_start;
+  IFQ_SET_READY(&ifp->if_snd);
 
   /*
    * init softc
@@ -751,6 +797,9 @@
     sz -= (EN_TXSZ * 1024);
     sc->txslot[lcv].stop = ptr;
     sc->txslot[lcv].nref = 0;
+#ifdef ATM_PVCEXT
+    sc->txrrp = NULL;
+#endif
     bzero(&sc->txslot[lcv].indma, sizeof(sc->txslot[lcv].indma));
     bzero(&sc->txslot[lcv].q, sizeof(sc->txslot[lcv].q));
 #ifdef EN_DEBUG
@@ -822,6 +871,9 @@
 #if NBPF > 0 
   BPFATTACH(ifp, DLT_ATM_RFC1483, sizeof(struct atmllc));
 #endif
+#ifdef ATM_PVCEXT
+  rrp_add(sc, ifp);
+#endif
 }
 
 
@@ -839,7 +891,7 @@
  * p166:   bestburstlen=64, alburst=0 
  */
 
-#if 1 /* __FreeBSD__ */
+#if defined(__FreeBSD__) && defined(__i386__)
 #define NBURSTS	3	/* number of bursts to use for dmaprobe */
 #define BOUNDARY 1024	/* test misaligned dma crossing the bounday.
 			   should be n * 64.  at least 64*(NBURSTS+1).
@@ -932,7 +984,7 @@
  * en_dmaprobe_doit: do actual testing
  */
 
-static int
+STATIC int
 en_dmaprobe_doit(sc, sp, dp, wmtry)
 
 struct en_softc *sc;
@@ -985,8 +1037,8 @@
   for (lcv = 8 ; lcv <= MIDDMA_MAXBURST ; lcv = lcv * 2) {
 
 #ifdef EN_DEBUG
-    printf("DMA test lcv=%d, sp=0x%x, dp=0x%x, wmtry=%d\n",
-	   lcv, sp, dp, wmtry);
+    printf("DMA test lcv=%d, sp=0x%lx, dp=0x%lx, wmtry=%d\n",
+	   lcv, (unsigned long)sp, (unsigned long)dp, wmtry);
 #endif
 
     /* zero SRAM and dest buffer */
@@ -1184,6 +1236,9 @@
 		break;
 #endif
 	case SIOCSIFADDR: 
+#if defined(INET6) && defined(SIOCSIFADDR_IN6)
+	case SIOCSIFADDR_IN6: 
+#endif
 		ifp->if_flags |= IFF_UP;
 #if defined(INET) || defined(INET6)
 		if (ifa->ifa_addr->sa_family == AF_INET
@@ -1204,7 +1259,18 @@
 		break;
 
 	case SIOCSIFFLAGS: 
+#ifdef ATM_PVCEXT
+	  	/* point-2-point pvc is allowed to change if_flags */
+		if (((ifp->if_flags & IFF_UP)
+		     && !(ifp->if_flags & IFF_RUNNING))
+		    || (!(ifp->if_flags & IFF_UP)
+			&& (ifp->if_flags & IFF_RUNNING))) {
+			en_reset(sc);
+			en_init(sc);
+		}
+#else
 		error = EINVAL;
+#endif
 		break;
 
 #if defined(SIOCSIFMTU)		/* ??? copied from if_de */
@@ -1228,6 +1294,110 @@
 	    break;
 #endif /* SIOCSIFMTU */
 
+#ifdef ATM_PVCEXT
+	case SIOCADDMULTI:
+	case SIOCDELMULTI:
+		if (ifp == &sc->enif || ifr == 0) {
+			error = EAFNOSUPPORT;	/* XXX */
+			break;
+		}
+		switch (ifr->ifr_addr.sa_family) {
+#ifdef INET
+		case AF_INET:
+			break;
+#endif
+#ifdef INET6
+		case AF_INET6:
+			break;
+#endif
+		default:
+			error = EAFNOSUPPORT;
+			break;
+		}
+		break;
+
+	case SIOCGPVCSIF:
+		if (ifp != &sc->enif) {
+#ifdef __NetBSD__
+		  strcpy(ifr->ifr_name, sc->enif.if_xname);
+#else
+		  sprintf(ifr->ifr_name, "%s%d",
+			  sc->enif.if_name, sc->enif.if_unit);
+#endif
+		}
+		else
+		  error = EINVAL;
+		break;
+
+	case SIOCSPVCSIF:
+		if (ifp == &sc->enif) {
+		  struct ifnet *sifp;
+		    
+#if (__FreeBSD_version >= 400000)
+		  if ((error = suser(curproc)) != 0)
+		    break;
+#else
+		  if (error = suser(curproc->p_ucred, &curproc->p_acflag))
+		    break;
+#endif
+
+		  if ((sifp = en_pvcattach(ifp)) != NULL) {
+#ifdef __NetBSD__
+		    strcpy(ifr->ifr_name, sifp->if_xname);
+#else
+		    sprintf(ifr->ifr_name, "%s%d",
+			    sifp->if_name, sifp->if_unit);
+#endif
+#if defined(__KAME__) && defined(INET6)
+		    /* get EUI64 for PVC, from ATM hardware interface */
+		    in6_ifattach(sifp, ifp);
+#endif
+		  }
+		  else
+		    error = ENOMEM;
+		}
+		else
+		  error = EINVAL;
+		break;
+
+	case SIOCGPVCTX:
+		error = en_pvctxget(sc, (struct pvctxreq *)data);
+		break;
+
+	case SIOCSPVCTX:
+#if (__FreeBSD_version >= 400000)
+		if ((error = suser(curproc)) == 0)
+			error = en_pvctx(sc, (struct pvctxreq *)data);
+#else
+		if ((error = suser(curproc->p_ucred, &curproc->p_acflag)) == 0)
+			error = en_pvctx(sc, (struct pvctxreq *)data);
+#endif
+		break;
+
+	case SIOCGPVCFWD:
+	{
+		struct pvcfwdreq *req = (struct pvcfwdreq *)data;
+		error = pvc_set_fwd(req->pvc_ifname, req->pvc_ifname2, 2);
+		break;
+	}	
+
+	case SIOCSPVCFWD:
+	{
+		struct pvcfwdreq *req = (struct pvcfwdreq *)data;
+#if (__FreeBSD_version >= 400000)
+		if ((error = suser(curproc)) == 0)
+			error = pvc_set_fwd(req->pvc_ifname, req->pvc_ifname2,
+					    req->pvc_op);
+#else
+		if ((error = suser(curproc->p_ucred, &curproc->p_acflag)) == 0)
+			error = pvc_set_fwd(req->pvc_ifname, req->pvc_ifname2,
+					    req->pvc_op);
+#endif
+		break;
+	}
+
+#endif /* ATM_PVCEXT */
+
 	default: 
 	    error = EINVAL;
 	    break;
@@ -1369,12 +1539,14 @@
       if (m == NULL) 
 	break;		/* >>> exit 'while(1)' here <<< */
       m_freem(m);
+      IF_DROP(&sc->enif.if_snd);
     }
     while (1) {
       IF_DEQUEUE(&sc->rxslot[slot].q, m);
       if (m == NULL) 
 	break;		/* >>> exit 'while(1)' here <<< */
       m_freem(m);
+      IF_DROP(&sc->enif.if_snd);
     }
     sc->rxslot[slot].oth_flags &= ~ENOTHER_SWSL;
     if (sc->rxslot[slot].oth_flags & ENOTHER_DRAIN) {
@@ -1403,7 +1575,6 @@
 	break;		/* >>> exit 'while(1)' here <<< */
       m_freem(m);
     }
-
     sc->txslot[lcv].mbsize = 0;
   }
 
@@ -1422,8 +1593,23 @@
 {
   int vc, slot;
   u_int32_t loc;
+#ifdef ATM_PVCEXT
+    struct pvcsif *pvcsif;
+#endif
 
   if ((sc->enif.if_flags & IFF_UP) == 0) {
+#ifdef ATM_PVCEXT
+    LIST_FOREACH(pvcsif, &sc->sif_list, sif_links) {
+      if (pvcsif->sif_if.if_flags & IFF_UP) {
+	/*
+	 * down the device only when there is no active pvc subinterface.
+	 * if there is, we have to go through the init sequence to reflect
+	 * the software states to the device.
+	 */
+	goto up;
+      }
+    }
+#endif
 #ifdef EN_DEBUG
     printf("%s: going down\n", sc->sc_dev.dv_xname);
 #endif
@@ -1432,10 +1618,18 @@
     return;
   }
 
+#ifdef ATM_PVCEXT
+ up:
+#endif
 #ifdef EN_DEBUG
   printf("%s: going up\n", sc->sc_dev.dv_xname);
 #endif
   sc->enif.if_flags |= IFF_RUNNING;	/* enable */
+#ifdef ATM_PVCEXT
+  LIST_FOREACH(pvcsif, &sc->sif_list, sif_links) {
+    pvcsif->sif_if.if_flags |= IFF_RUNNING;
+  }
+#endif
 
   if (sc->en_busreset)
     sc->en_busreset(sc);
@@ -1492,7 +1686,7 @@
     EN_WRITE(sc, MIDX_PLACE(slot), MIDX_MKPLACE(en_k2sz(EN_TXSZ), loc));
 #ifdef EN_DEBUG
     printf("%s: tx%d: place 0x%x\n", sc->sc_dev.dv_xname,  slot,
-	EN_READ(sc, MIDX_PLACE(slot)));
+	(u_int)EN_READ(sc, MIDX_PLACE(slot)));
 #endif
   }
 
@@ -1552,7 +1746,6 @@
 
 {
     struct en_softc *sc = (struct en_softc *) ifp->if_softc;
-    struct ifqueue *ifq = &ifp->if_snd; /* if INPUT QUEUE */
     struct mbuf *m, *lastm, *prev;
     struct atm_pseudohdr *ap, *new_ap;
     int txchan, mlen, got, need, toadd, cellcnt, first;
@@ -1569,7 +1762,7 @@
 
     while (1) {
 
-      IF_DEQUEUE(ifq, m);
+      IFQ_DEQUEUE(&ifp->if_snd, m);
       if (m == NULL)
 	return;		/* EMPTY: >>> exit here <<< */
     
@@ -1595,6 +1788,7 @@
 	    if (en_mfix(sc, &lastm, prev) == 0) {	/* failed? */
 	      m_freem(m);
 	      m = NULL;
+	      sc->enif.if_oerrors++;
               break;
             }
 	    if (first)
@@ -1628,6 +1822,7 @@
 	printf("%s: output vpi=%d, vci=%d out of card range, dropping...\n", 
 		sc->sc_dev.dv_xname, atm_vpi, atm_vci);
 	m_freem(m);
+	sc->enif.if_oerrors++;
 	continue;
       }
 
@@ -1644,7 +1839,7 @@
        *	[including AAL5 PDU, if AAL5]
        */
 
-      got = mlen - sizeof(struct atm_pseudohdr *);
+      got = mlen - sizeof(struct atm_pseudohdr);
       toadd = (aal == MID_TBD_AAL5) ? MID_PDU_SIZE : 0;	/* PDU */
       cellcnt = (got + toadd + (MID_ATMDATASZ - 1)) / MID_ATMDATASZ;
       need = cellcnt * MID_ATMDATASZ;
@@ -1654,7 +1849,7 @@
       printf("%s: txvci%d: mlen=%d, got=%d, need=%d, toadd=%d, cell#=%d\n",
 	sc->sc_dev.dv_xname, atm_vci, mlen, got, need, toadd, cellcnt);
       printf("     leading_space=%d, trailing_space=%d\n", 
-	M_LEADINGSPACE(m), M_TRAILINGSPACE(lastm));
+	(int)M_LEADINGSPACE(m), (int)M_TRAILINGSPACE(lastm));
 #endif
 
 #ifdef EN_MBUF_OPT
@@ -1707,6 +1902,7 @@
       if (sc->txslot[txchan].mbsize > EN_TXHIWAT) {
 	EN_COUNT(sc->txmbovr);
 	m_freem(m);
+	IF_DROP(&ifp->if_snd);
 #ifdef EN_DEBUG
 	printf("%s: tx%d: buffer space shortage\n", sc->sc_dev.dv_xname,
 		txchan);
@@ -1759,7 +1955,7 @@
 #endif
 
   d = mtod(m, u_char *);
-  off = ((unsigned long) d) % sizeof(u_int32_t);
+  off = ((uintptr_t) (void *) d) % sizeof(u_int32_t);
 
   if (off) {
     if ((m->m_flags & M_EXT) == 0) {
@@ -1886,12 +2082,12 @@
 
   EN_COUNT(sc->mfix);			/* count # of calls */
 #ifdef EN_DEBUG
-  printf("%s: mfix mbuf m_data=0x%x, m_len=%d\n", sc->sc_dev.dv_xname,
+  printf("%s: mfix mbuf m_data=%p, m_len=%d\n", sc->sc_dev.dv_xname,
 	m->m_data, m->m_len);
 #endif
 
   d = mtod(m, u_char *);
-  off = ((uintptr_t) (void *) d) % sizeof(u_int32_t);
+  off = ((unsigned long) d) % sizeof(u_int32_t);
 
   if (off) {
     if ((m->m_flags & M_EXT) == 0) {
@@ -2103,7 +2299,12 @@
    */
 
   EN_COUNT(sc->launch);
+#ifdef ATM_PVCEXT
+  /* if there's a subinterface for this vci, override ifp. */
+  ifp = en_vci2ifp(sc, launch.atm_vci);
+#else
   ifp = &sc->enif;
+#endif
   ifp->if_opackets++;
   
   if ((launch.atm_flags & EN_OBHDR) == 0) {
@@ -2160,6 +2361,7 @@
   if (launch.t != tmp)
     panic("en dequeue drop");
   m_freem(launch.t);
+  IF_DROP(&sc->enif.if_snd);
   sc->txslot[chan].mbsize -= launch.mlen;
   goto again;
 }
@@ -2217,8 +2419,9 @@
 	sc->sc_dev.dv_xname, chan, l->t, cur, (cur-start)/4, need, addtail);
   count = EN_READ(sc, MIDX_PLACE(chan));
   printf("     HW: base_address=0x%x, size=%d, read=%d, descstart=%d\n",
-	MIDX_BASE(count), MIDX_SZ(count), EN_READ(sc, MIDX_READPTR(chan)), 
-	EN_READ(sc, MIDX_DESCSTART(chan)));
+	 (u_int)MIDX_BASE(count), MIDX_SZ(count),
+	 (int)EN_READ(sc, MIDX_READPTR(chan)),
+	 (int)EN_READ(sc, MIDX_DESCSTART(chan)));
 #endif
 
  /*
@@ -2492,7 +2695,7 @@
       pad -= 2;
 #ifdef EN_DEBUG
       printf("%s: tx%d: padding %d bytes (cur now 0x%x)\n", 
-		sc->sc_dev.dv_xname, chan, pad * sizeof(u_int32_t), cur);
+	     sc->sc_dev.dv_xname, chan, (int)(pad * sizeof(u_int32_t)), cur);
 #endif
     while (pad--) {
       EN_WRITEDAT(sc, cur, 0);	/* no byte order issues with zero */
@@ -2705,8 +2908,15 @@
 		EN_DQ_LEN(drq), sc->rxslot[slot].rxhand);
 #endif
 
+#ifdef ATM_PVCEXT
+	  /* if there's a subinterface for this vci, override ifp. */
+	  ifp = en_vci2ifp(sc, sc->rxslot[slot].atm_vci);
+	  ifp->if_ipackets++;
+	  m->m_pkthdr.rcvif = ifp;	/* XXX */
+#else
 	  ifp = &sc->enif;
 	  ifp->if_ipackets++;
+#endif
 
 #if NBPF > 0
 	  if (ifp->if_bpf)
@@ -2796,6 +3006,28 @@
   sc->vtrash += MID_VTRASH(reg);
 #endif
 
+#ifdef ATM_PVCEXT
+  /*
+   * when the tx buffer is full, packets are left in the interface queue.
+   * (en dequeues all packets even when the tx buffer is full.)
+   * call en_start for each pvc interface using round-robin scheduling
+   * to avoid starvation.
+   */
+  if (kick) {
+    struct rrp *rrp_start;
+
+    if ((rrp_start = sc->txrrp) != NULL) {
+      while (1) {
+	en_start(sc->txrrp->ifp);
+	if (sc->txrrp->next == rrp_start)
+	  break;
+	else
+	  sc->txrrp = sc->txrrp->next;
+      }
+    }
+  }
+#endif
+
   EN_INTR_RET(1); /* for us */
 }
 
@@ -2941,7 +3173,11 @@
 	}
 	fill = tlen;
 
+#ifdef ATM_PVCEXT
+	ifp = en_vci2ifp(sc, vci);
+#else
 	ifp = &sc->enif;
+#endif
 	ifp->if_ierrors++;
 
       }
@@ -3257,9 +3493,22 @@
   struct en_softc *sc;
   int lcv, cnt, slot;
   u_int32_t ptr, reg;
+#ifdef __FreeBSD__
+  devclass_t dc;
+  int maxunit;
 
+  dc = devclass_find("en");
+  if (dc == NULL) {
+    printf("en_dump: can't find devclass!\n");
+    return 0;
+  }
+  maxunit = devclass_get_maxunit(dc);
+  for (lcv = 0 ; lcv < maxunit ; lcv++) {
+    sc = devclass_get_softc(dc, lcv);
+#else
   for (lcv = 0 ; lcv < en_cd.cd_ndevs ; lcv++) {
     sc = (struct en_softc *) en_cd.cd_devs[lcv];
+#endif
     if (sc == NULL) continue;
     if (unit != -1 && unit != lcv)
       continue;
@@ -3308,24 +3557,21 @@
 
     if (level & END_MREGS) {
       printf("mregs:\n");
-      printf("resid = 0x%lx\n", (u_long)EN_READ(sc, MID_RESID));
+      printf("resid = 0x%x\n", EN_READ(sc, MID_RESID));
       printf("interrupt status = 0x%b\n", 
-				(int)EN_READ(sc, MID_INTSTAT), MID_INTBITS);
+	     (int)EN_READ(sc, MID_INTSTAT), MID_INTBITS);
       printf("interrupt enable = 0x%b\n", 
-				(int)EN_READ(sc, MID_INTENA), MID_INTBITS);
+	     (int)EN_READ(sc, MID_INTENA), MID_INTBITS);
       printf("mcsr = 0x%b\n", (int)EN_READ(sc, MID_MAST_CSR), MID_MCSRBITS);
-      printf("serv_write = [chip=%ld] [us=%d]\n",
-			(long)EN_READ(sc, MID_SERV_WRITE),
-			MID_SL_A2REG(sc->hwslistp));
-      printf("dma addr = 0x%lx\n", (u_long)EN_READ(sc, MID_DMA_ADDR));
-      printf("DRQ: chip[rd=0x%lx,wr=0x%lx], sc[chip=0x%x,us=0x%x]\n",
-	(u_long)MID_DRQ_REG2A(EN_READ(sc, MID_DMA_RDRX)), 
-	(u_long)MID_DRQ_REG2A(EN_READ(sc, MID_DMA_WRRX)),
-	sc->drq_chip, sc->drq_us);
-      printf("DTQ: chip[rd=0x%lx,wr=0x%lx], sc[chip=0x%x,us=0x%x]\n",
-	(u_long)MID_DTQ_REG2A(EN_READ(sc, MID_DMA_RDTX)), 
-	(u_long)MID_DTQ_REG2A(EN_READ(sc, MID_DMA_WRTX)),
-	sc->dtq_chip, sc->dtq_us);
+      printf("serv_write = [chip=%u] [us=%u]\n", EN_READ(sc, MID_SERV_WRITE),
+	     MID_SL_A2REG(sc->hwslistp));
+      printf("dma addr = 0x%x\n", EN_READ(sc, MID_DMA_ADDR));
+      printf("DRQ: chip[rd=0x%x,wr=0x%x], sc[chip=0x%x,us=0x%x]\n",
+	MID_DRQ_REG2A(EN_READ(sc, MID_DMA_RDRX)), 
+	MID_DRQ_REG2A(EN_READ(sc, MID_DMA_WRRX)), sc->drq_chip, sc->drq_us);
+      printf("DTQ: chip[rd=0x%x,wr=0x%x], sc[chip=0x%x,us=0x%x]\n",
+	MID_DTQ_REG2A(EN_READ(sc, MID_DMA_RDTX)), 
+	MID_DTQ_REG2A(EN_READ(sc, MID_DMA_WRTX)), sc->dtq_chip, sc->dtq_us);
 
       printf("  unusal txspeeds: ");
       for (cnt = 0 ; cnt < MID_N_VC ; cnt++)
@@ -3349,11 +3595,10 @@
 		(sc->txslot[slot].cur - sc->txslot[slot].start)/4);
 	printf("mbsize=%d, bfree=%d\n", sc->txslot[slot].mbsize,
 		sc->txslot[slot].bfree);
-        printf("txhw: base_address=0x%lx, size=%ld, read=%ld, descstart=%ld\n",
-	  (u_long)MIDX_BASE(EN_READ(sc, MIDX_PLACE(slot))), 
-	  (u_long)MIDX_SZ(EN_READ(sc, MIDX_PLACE(slot))),
-	  (long)EN_READ(sc, MIDX_READPTR(slot)),
-	  (long)EN_READ(sc, MIDX_DESCSTART(slot)));
+        printf("txhw: base_address=0x%x, size=%u, read=%u, descstart=%u\n",
+	  (u_int)MIDX_BASE(EN_READ(sc, MIDX_PLACE(slot))), 
+	  MIDX_SZ(EN_READ(sc, MIDX_PLACE(slot))),
+	  EN_READ(sc, MIDX_READPTR(slot)), EN_READ(sc, MIDX_DESCSTART(slot)));
       }
     }
 
@@ -3366,10 +3611,10 @@
 	printf("mode=0x%x, atm_flags=0x%x, oth_flags=0x%x\n", 
 	sc->rxslot[slot].mode, sc->rxslot[slot].atm_flags, 
 		sc->rxslot[slot].oth_flags);
-        printf("RXHW: mode=0x%lx, DST_RP=0x%lx, WP_ST_CNT=0x%lx\n",
-	  (u_long)EN_READ(sc, MID_VC(sc->rxslot[slot].atm_vci)),
-	  (u_long)EN_READ(sc, MID_DST_RP(sc->rxslot[slot].atm_vci)),
-	  (u_long)EN_READ(sc, MID_WP_ST_CNT(sc->rxslot[slot].atm_vci)));
+        printf("RXHW: mode=0x%x, DST_RP=0x%x, WP_ST_CNT=0x%x\n",
+	  EN_READ(sc, MID_VC(sc->rxslot[slot].atm_vci)),
+	  EN_READ(sc, MID_DST_RP(sc->rxslot[slot].atm_vci)),
+	  EN_READ(sc, MID_WP_ST_CNT(sc->rxslot[slot].atm_vci)));
       }
     }
 
@@ -3379,10 +3624,9 @@
       ptr = sc->dtq_chip;
       while (ptr != sc->dtq_us) {
         reg = EN_READ(sc, ptr);
-        printf("\t0x%x=[cnt=%d, chan=%d, end=%d, type=%d @ 0x%lx]\n", 
+        printf("\t0x%x=[cnt=%d, chan=%d, end=%d, type=%d @ 0x%x]\n", 
 	    sc->dtq[MID_DTQ_A2REG(ptr)], MID_DMA_CNT(reg), MID_DMA_TXCHAN(reg),
-	    (reg & MID_DMA_END) != 0, MID_DMA_TYPE(reg),
-	    (u_long)EN_READ(sc, ptr+4));
+	    (reg & MID_DMA_END) != 0, MID_DMA_TYPE(reg), EN_READ(sc, ptr+4));
         EN_WRAPADD(MID_DTQOFF, MID_DTQEND, ptr, 8);
       }
     }
@@ -3393,10 +3637,9 @@
       ptr = sc->drq_chip;
       while (ptr != sc->drq_us) {
         reg = EN_READ(sc, ptr);
-	printf("\t0x%x=[cnt=%d, chan=%d, end=%d, type=%d @ 0x%lx]\n", 
+	printf("\t0x%x=[cnt=%d, chan=%d, end=%d, type=%d @ 0x%x]\n", 
 	  sc->drq[MID_DRQ_A2REG(ptr)], MID_DMA_CNT(reg), MID_DMA_RXVCI(reg),
-	  (reg & MID_DMA_END) != 0, MID_DMA_TYPE(reg),
-	  (u_long)EN_READ(sc, ptr+4));
+	  (reg & MID_DMA_END) != 0, MID_DMA_TYPE(reg), EN_READ(sc, ptr+4));
 	EN_WRAPADD(MID_DRQOFF, MID_DRQEND, ptr, 8);
       }
     }
@@ -3424,12 +3667,23 @@
 {
   struct en_softc *sc;
   u_int32_t reg;
+#ifdef __FreeBSD__
+  devclass_t dc;
 
+  dc = devclass_find("en");
+  if (dc == NULL) {
+    printf("en_dumpmem: can't find devclass!\n");
+    return 0;
+  }
+  sc = devclass_get_softc(dc, unit);
+#else
   if (unit < 0 || unit > en_cd.cd_ndevs ||
 	(sc = (struct en_softc *) en_cd.cd_devs[unit]) == NULL) {
     printf("invalid unit number: %d\n", unit);
     return(0);
   }
+#endif
+
   addr = addr & ~3;
   if (addr < MID_RAMOFF || addr + len*4 > MID_MAXOFF || len <= 0) {
     printf("invalid addr/len number: %d, %d\n", addr, len);
@@ -3444,3 +3698,422 @@
   return(0);
 }
 #endif
+
+#ifdef ATM_PVCEXT
+/*
+ * ATM PVC extention: shaper control and pvc subinterfaces
+ */
+
+/*
+ * the list of the interfaces sharing the physical device.
+ * in order to avoid starvation, the interfaces are scheduled in
+ * a round-robin fashion when en_start is called from tx complete
+ * interrupts.
+ */
+static void rrp_add(sc, ifp)
+	struct en_softc *sc;
+	struct ifnet *ifp;
+{
+	struct rrp *head, *p, *new;
+
+	head = sc->txrrp;
+	if ((p = head) != NULL) {
+		while (1) {
+			if (p->ifp == ifp) {
+				/* an entry for this ifp already exits */
+				p->nref++;
+				return;
+			}
+			if (p->next == head)
+				break;
+			p = p->next;
+		}
+	}
+	
+	/* create a new entry */
+	MALLOC(new, struct rrp *, sizeof(struct rrp), M_DEVBUF, M_WAITOK);
+	if (new == NULL) {
+		printf("en_rrp_add: malloc failed!\n");
+		return;
+	}
+
+	new->ifp = ifp;
+	new->nref = 1;
+
+	if (p == NULL) {
+		/* this is the only one in the list */
+		new->next = new;
+		sc->txrrp = new;
+	}
+	else {
+		/* add the new entry at the tail of the list */
+		new->next = p->next;
+		p->next = new;
+	}
+}
+
+#if 0 /* not used */
+static void rrp_delete(sc, ifp)
+	struct en_softc *sc;
+	struct ifnet *ifp;
+{
+	struct rrp *head, *p, *prev;
+
+	head = sc->txrrp;
+
+	prev = head;
+	if (prev == NULL) {
+		printf("rrp_delete: no list!\n");
+		return;
+	}
+	p = prev->next;
+
+	while (1) {
+		if (p->ifp == ifp) {
+			p->nref--;
+			if (p->nref > 0)
+				return;
+			/* remove this entry */
+			if (p == prev) {
+				/* this is the only entry in the list */
+				sc->txrrp = NULL;
+			}
+			else {
+				prev->next = p->next;
+				if (head == p)
+					sc->txrrp = p->next;
+			}
+			FREE(p, M_DEVBUF);
+		}
+		prev = p;
+		p = prev->next;
+		if (prev == head) {
+			printf("rrp_delete: no matching entry!\n");
+			return;
+		}
+	}
+}
+#endif /* 0 */
+
+static struct ifnet *
+en_vci2ifp(sc, vci)
+	struct en_softc *sc;
+	int vci;
+{
+	struct pvcsif *pvcsif;
+
+	LIST_FOREACH(pvcsif, &sc->sif_list, sif_links) {
+		if (vci == pvcsif->sif_vci)
+			return (&pvcsif->sif_if);
+	}
+	return (&sc->enif);
+}
+
+/*
+ * create and attach per pvc subinterface
+ * (currently detach is not supported)
+ */
+static struct ifnet *
+en_pvcattach(ifp)
+	struct ifnet *ifp;
+{
+	struct en_softc *sc = (struct en_softc *) ifp->if_softc;
+	struct ifnet *pvc_ifp;
+	int s;
+
+	if ((pvc_ifp = pvcsif_alloc()) == NULL)
+		return (NULL);
+
+	pvc_ifp->if_softc = sc;
+	pvc_ifp->if_ioctl = en_ioctl;
+	pvc_ifp->if_start = en_start;
+	pvc_ifp->if_flags = (IFF_POINTOPOINT|IFF_MULTICAST) |
+		(ifp->if_flags & (IFF_RUNNING|IFF_SIMPLEX|IFF_NOTRAILERS));
+	IFQ_SET_READY(&pvc_ifp->if_snd);
+
+	s = splimp();
+	LIST_INSERT_HEAD(&sc->sif_list, (struct pvcsif *)pvc_ifp, sif_links);
+	if_attach(pvc_ifp);
+	atm_ifattach(pvc_ifp); 
+
+#if NBPF > 0 
+	BPFATTACH(pvc_ifp, DLT_ATM_RFC1483, sizeof(struct atmllc));
+#endif
+#ifdef ATM_PVCEXT
+	rrp_add(sc, pvc_ifp);
+#endif
+	splx(s);
+
+	return (pvc_ifp);
+}
+
+
+/* txspeed conversion derived from linux drivers/atm/eni.c
+   by Werner Almesberger, EPFL LRC */
+static const int pre_div[] = { 4,16,128,2048 };
+
+static int en_pcr2txspeed(pcr)
+	int pcr;
+{
+	int pre, res, div;
+
+	if (pcr == 0 || pcr > 347222)
+		pre = res = 0;	/* max rate */
+	else {
+		for (pre = 0; pre < 3; pre++)
+			if (25000000/pre_div[pre]/64 <= pcr)
+				break;
+		div = pre_div[pre]*(pcr);
+#if 1
+		/*
+		 * the shaper value should be rounded down,
+		 * instead of rounded up.
+		 * (which means "res" should be rounded up.)
+		 */
+		res = (25000000 + div -1)/div - 1;
+#else
+		res = 25000000/div-1;
+#endif
+		if (res < 0)
+			res = 0;
+		if (res > 63)
+			res = 63;
+	}
+	return ((pre << 6) + res);
+}
+
+static int en_txspeed2pcr(txspeed)
+	int txspeed;
+{
+	int pre, res, pcr;
+
+	pre = (txspeed >> 6) & 0x3;
+	res = txspeed & 0x3f;
+	pcr = 25000000 / pre_div[pre] / (res+1);
+	return (pcr);
+}
+
+/*
+ * en_txctl selects a hardware transmit channel and sets the shaper value.
+ * en_txctl should be called after enabling the vc by en_rxctl
+ * since it assumes a transmit channel is already assigned by en_rxctl
+ * to the vc.
+ */
+static int en_txctl(sc, vci, joint_vci, pcr)
+	struct en_softc *sc;
+	int vci;
+	int joint_vci;
+	int pcr;
+{
+	int txspeed, txchan, s;
+
+	if (pcr)
+		txspeed = en_pcr2txspeed(pcr);
+	else
+		txspeed = 0;
+
+	s = splimp();
+	txchan = sc->txvc2slot[vci];
+	sc->txslot[txchan].nref--;
+    
+	/* select a slot */
+	if (joint_vci != 0)
+		/* use the same channel */
+		txchan = sc->txvc2slot[joint_vci];
+	else if (pcr == 0)
+		txchan = 0;
+	else {
+		for (txchan = 1; txchan < EN_NTX; txchan++) {
+			if (sc->txslot[txchan].nref == 0)
+				break;
+		}
+	}
+	if (txchan == EN_NTX) {
+#if 1
+		/* no free slot! */
+		splx(s);
+		return (ENOSPC);
+#else
+		/*
+		 * to allow multiple vc's to share a slot,
+		 * use a slot with the smallest reference count
+		 */
+		int slot = 1;
+		txchan = 1;
+		for (slot = 2; slot < EN_NTX; slot++)
+			if (sc->txslot[slot].nref < sc->txslot[txchan].nref)
+				txchan = slot;
+#endif
+	}
+
+	sc->txvc2slot[vci] = txchan;
+	sc->txslot[txchan].nref++;
+
+	/* set the shaper parameter */
+	sc->txspeed[vci] = (u_int8_t)txspeed;
+
+	splx(s);
+#ifdef EN_DEBUG
+	printf("VCI:%d PCR set to %d, tx channel %d\n", vci, pcr, txchan);
+	if (joint_vci != 0)
+		printf("  slot shared with VCI:%d\n", joint_vci);
+#endif
+	return (0);
+}
+
+static int en_pvctx(sc, pvcreq)
+	struct en_softc *sc;
+	struct pvctxreq *pvcreq;
+{
+	struct ifnet *ifp;
+	struct atm_pseudoioctl api;
+	struct atm_pseudohdr *pvc_aph, *pvc_joint;
+	int vci, joint_vci, pcr;
+	int error = 0;
+
+	/* check vpi:vci values */
+	pvc_aph = &pvcreq->pvc_aph;
+	pvc_joint = &pvcreq->pvc_joint;
+
+	vci = ATM_PH_VCI(pvc_aph);
+	joint_vci = ATM_PH_VCI(pvc_joint);
+	pcr = pvcreq->pvc_pcr;
+
+	if (ATM_PH_VPI(pvc_aph) != 0 || vci >= MID_N_VC ||
+	    ATM_PH_VPI(pvc_joint) != 0 || joint_vci >= MID_N_VC)
+		return (EADDRNOTAVAIL);
+
+	if ((ifp = ifunit(pvcreq->pvc_ifname)) == NULL)
+		return (ENXIO);
+
+	if (pcr < 0) {
+		/* negative pcr means disable the vc. */
+		if (sc->rxvc2slot[vci] == RX_NONE)
+			/* already disabled */
+			return 0;
+
+		ATM_PH_FLAGS(&api.aph) = 0;
+		ATM_PH_VPI(&api.aph) = 0;
+		ATM_PH_SETVCI(&api.aph, vci);
+		api.rxhand = NULL;
+
+		error = en_rxctl(sc, &api, 0);
+		
+		if (error == 0 && &sc->enif != ifp) {
+			/* clear vc info of this subinterface */
+			struct pvcsif *pvcsif = (struct pvcsif *)ifp;
+
+			ATM_PH_SETVCI(&api.aph, 0);
+			pvcsif->sif_aph = api.aph;
+			pvcsif->sif_vci = 0;
+		}
+		return (error);
+	}
+
+	if (&sc->enif == ifp) {
+		/* called for an en interface */
+		if (sc->rxvc2slot[vci] == RX_NONE) {
+			/* vc is not active */
+#ifdef __NetBSD__
+			printf("%s: en_pvctx: rx not active! vci=%d\n",
+			       ifp->if_xname, vci);
+#else
+			printf("%s%d: en_pvctx: rx not active! vci=%d\n",
+			       ifp->if_name, ifp->if_unit, vci);
+#endif
+			return (EINVAL);
+		}
+	}
+	else {
+		/* called for a pvc subinterface */
+		struct pvcsif *pvcsif = (struct pvcsif *)ifp;
+
+#ifdef __NetBSD__
+    		strcpy(pvcreq->pvc_ifname, sc->enif.if_xname);
+#else
+    		sprintf(pvcreq->pvc_ifname, "%s%d",
+			sc->enif.if_name, sc->enif.if_unit);
+#endif
+		ATM_PH_FLAGS(&api.aph) =
+			(ATM_PH_FLAGS(pvc_aph) & (ATM_PH_AAL5|ATM_PH_LLCSNAP));
+		ATM_PH_VPI(&api.aph) = 0;
+		ATM_PH_SETVCI(&api.aph, vci);
+		api.rxhand = NULL;
+		pvcsif->sif_aph = api.aph;
+		pvcsif->sif_vci = ATM_PH_VCI(&api.aph);
+
+		if (sc->rxvc2slot[vci] == RX_NONE) {
+			/* vc is not active, enable rx */
+			error = en_rxctl(sc, &api, 1);
+			if (error)
+				return error;
+		}
+		else {
+			/* vc is already active, update aph in softc */
+			sc->rxslot[sc->rxvc2slot[vci]].atm_flags =
+				ATM_PH_FLAGS(&api.aph);
+		}
+	}
+
+	error = en_txctl(sc, vci, joint_vci, pcr);
+
+	if (error == 0) {
+		if (sc->txspeed[vci] != 0)
+			pvcreq->pvc_pcr = en_txspeed2pcr(sc->txspeed[vci]);
+		else
+			pvcreq->pvc_pcr = 0;
+	}
+
+	return error;
+}
+
+static int en_pvctxget(sc, pvcreq)
+	struct en_softc *sc;
+	struct pvctxreq *pvcreq;
+{
+	struct pvcsif *pvcsif;
+	struct ifnet *ifp;
+	int vci, slot;
+
+	if ((ifp = ifunit(pvcreq->pvc_ifname)) == NULL)
+		return (ENXIO);
+
+	if (ifp == &sc->enif) {
+		/* physical interface: assume vci is specified */
+		struct atm_pseudohdr *pvc_aph;
+
+		pvc_aph = &pvcreq->pvc_aph;
+		vci = ATM_PH_VCI(pvc_aph);
+		if ((slot = sc->rxvc2slot[vci]) == RX_NONE)
+			ATM_PH_FLAGS(pvc_aph) = 0;
+		else
+			ATM_PH_FLAGS(pvc_aph) = sc->rxslot[slot].atm_flags;
+		ATM_PH_VPI(pvc_aph) = 0;
+	}
+	else {
+		/* pvc subinterface */
+#ifdef __NetBSD__
+		strcpy(pvcreq->pvc_ifname, sc->enif.if_xname);
+#else
+		sprintf(pvcreq->pvc_ifname, "%s%d",
+			sc->enif.if_name, sc->enif.if_unit);
+#endif
+		pvcsif = (struct pvcsif *)ifp;
+		pvcreq->pvc_aph = pvcsif->sif_aph;
+		vci = pvcsif->sif_vci;
+	}
+
+	if ((slot = sc->rxvc2slot[vci]) == RX_NONE) {
+		/* vc is not active */
+		ATM_PH_FLAGS(&pvcreq->pvc_aph) = 0;
+		pvcreq->pvc_pcr = -1;
+	}
+	else if (sc->txspeed[vci])
+		pvcreq->pvc_pcr = en_txspeed2pcr(sc->txspeed[vci]);
+	else
+		pvcreq->pvc_pcr = 0;
+
+	return (0);
+}
+
+#endif /* ATM_PVCEXT */
diff -urN ../sys/dev/en/midwayreg.h ./dev/en/midwayreg.h
--- ../sys/dev/en/midwayreg.h	Wed Jul 29 14:34:12 1998
+++ ./dev/en/midwayreg.h	Tue Oct  2 22:06:19 2001
@@ -8,26 +8,6 @@
  *
  */
 
-#if defined(sparc) || defined(__FreeBSD__)
-/* XXX: gross.   netbsd/sparc doesn't have machine/bus.h yet. */
-typedef void * bus_space_tag_t;
-typedef u_int32_t pci_chipset_tag_t;
-typedef caddr_t bus_space_handle_t;
-typedef u_int32_t bus_size_t;
-typedef caddr_t bus_addr_t;
-
-#define bus_space_read_4(t, h, o) ((void) t,                            \
-    (*(volatile u_int32_t *)((h) + (o))))
-#define bus_space_write_4(t, h, o, v)                                   \
-    ((void) t, ((void)(*(volatile u_int32_t *)((h) + (o)) = (v))))
-
-#if defined(sparc)
-#define vtophys(x) ((u_int32_t)(x))	/* sun4c dvma */
-#endif
-
-#endif
-
-
 #define MID_SZTOB(X) 	((X) * 256 * 4) /* size to bytes */
 #define MID_BTOSZ(X)	((X) / 256 / 4)	/* bytes to "size" */
 
